#include <stdio.h>
#include <iostream>
#include "complex.h"


void test_cmul(Complex x, Complex y);
void test_phasor();
void test_polar();

void main()
{
	Complex x,y,z;
	x = Complex(1.0,-2.0);
	y = Complex(0.5,1.8);
	test_cmul(x,y);
	test_phasor();
	test_polar();
}

void test_cmul(Complex x, Complex y)
{
	Complex z;
	z = x * y;
	printf("x = (%s)\n", x.format().c_str());
	printf("y = (%s)\n", y.format().c_str());
	printf("z = x*y = (%5.2f %5.2f)\n", real(z), imag(z));
}

void test_phasor()
{
	Complex a,b,c;
	a = Complex::polar(10.0,30.0);
	b = Complex::polar(5.0,-60.0);
	cout << endl;
	cout << "a = " << a.phasor() << endl;
	cout << "b = " << b.phasor() << endl;
	c = a + b;
	cout << "a+b = " << c.phasor() << endl;
	a = Complex::polar(20.0);
	b = Complex::polar(15.0,-60.0);
	cout << "a = " << a.phasor() << endl;
	cout << "b = " << b.phasor() << endl;
	c = a + b;
	cout << "a+b = " << c.phasor() << endl;
}

void test_polar()
{
	Complex a,b;
	double r,theta;
	r = 4.0;
	printf("\n   theta    real    imag   modulus   phase\n");
	for (int i=0; i<13; i++) {
		theta = 30.0*i;
		if (theta>180.0) theta = theta - 360.0;
		a = Complex::polar(r,theta);
		b = sqrt(a);
		printf("%8.3f%8.3f%8.3f%10.3f%8.3f\n",theta,a.real(),a.imag(),b.mag(),b.angle()); 
	}
}

